## golang 1.0.2

=== doc/Makefile ===
# Copyright 2009 The Go Authors. All rights reserved.
# Use of this source code is governed by a BSD-style
# license that can be found in the LICENSE file.

RAWHTML=\
	articles/defer_panic_recover.rawhtml\
	articles/error_handling.rawhtml\
	articles/slices_usage_and_internals.rawhtml\
	articles/laws_of_reflection.rawhtml\
	articles/c_go_cgo.rawhtml\
	articles/concurrency_patterns.rawhtml\
	articles/godoc_documenting_go_code.rawhtml\
	articles/gobs_of_data.rawhtml\
	articles/json_and_go.rawhtml\
	articles/json_rpc_tale_of_interfaces.rawhtml\
	articles/image_draw.rawhtml\
	articles/image_package.rawhtml\
	effective_go.rawhtml\
	go1.rawhtml\

all: $(RAWHTML)

%.rawhtml: %.html
	godoc -url /doc/$< >$@

clean:
	rm -f $(RAWHTML)

=== misc/cgo/test/Makefile ===
# Copyright 2011 The Go Authors.  All rights reserved.
# Use of this source code is governed by a BSD-style
# license that can be found in the LICENSE file.

include ../../../src/Make.inc

TARG=runtime/cgotest

CGOFILES=\
	align.go\
	basic.go\
	callback.go\
	env.go\
	exports.go\
	helpers.go\
	issue1222.go\
	issue1328.go\
	issue1560.go\
	issue2462.go\
	duplicate_symbol.go\

CGO_OFILES=\
	callback_c.o\

OFILES=\
	runtime.$O\

ifeq ($(GOOS),windows)
GCCVERSION=$(shell gcc -dumpversion)
ifeq ($(GOARCH),386)
GCCLIBDIR=/mingw/lib/gcc/mingw32/$(GCCVERSION)
CHKSTK=_chkstk.o
else
GCCLIBDIR=/mingw/lib/gcc/x86_64-w64-mingw32/$(GCCVERSION)
CHKSTK=_chkstk_ms.o
endif

CGOFILES+=sleep_windows.go
CGO_OFILES+=$(CHKSTK)

$(CHKSTK):
	ar -x "$(GCCLIBDIR)/libgcc.a" $@
endif

include ../../../src/Make.pkg

test:
	echo cgo: tests disabled. gotest is gone. TODO

=== misc/dashboard/builder/Makefile ===
# Copyright 2009 The Go Authors. All rights reserved.
# Use of this source code is governed by a BSD-style
# license that can be found in the LICENSE file.

gobuilder: $(shell ls *.go)
	go build -o $@ $^

clean:
	rm -f gobuilder

=== misc/swig/stdio/Makefile ===
# Copyright 2011 The Go Authors.  All rights reserved.
# Use of this source code is governed by a BSD-style
# license that can be found in the LICENSE file.

include ../../../src/Make.inc

TARG=swig/file
SWIGFILES=\
	file.swig

CLEANFILES+=hello

include ../../../src/Make.pkg

%: install %.go
	$(GC) $(GCFLAGS) $(GCIMPORTS) $*.go
	$(LD) $(SWIG_RPATH) -o $@ $*.$O

=== src/cmd/cc/Makefile ===
# Copyright 2012 The Go Authors. All rights reserved.
# Use of this source code is governed by a BSD-style
# license that can be found in the LICENSE file.

include ../../Make.dist

install: y.tab.h

y.tab.h: cc.y
	LANG=C LANGUAGE=en_US.UTF8 bison -d -v -y a.y

## golang 1

=== debian/changelog ===
golang (2:1-5) unstable; urgency=low

  * Rewrite test conditions to make them more readable
    (and fix the debian/rules to really not check on armel+kfreebsd)
  * Patch upstream test to not fail on missing home directory

 -- Ondřej Surý <ondrej@debian.org>  Sun, 15 Apr 2012 12:35:53 +0200

golang (2:1-4) unstable; urgency=low

  * Disable tests on Debian GNU/KFreeBSD, they just hang now (Closes: #668794)
  * Disable tests on armel, but the invalid instruction needs fixing in
    upstream
  * Create fake home directory to pass the os/user test

 -- Ondřej Surý <ondrej@debian.org>  Sun, 15 Apr 2012 10:49:09 +0200

golang (2:1-3) unstable; urgency=high

  * Use VERSION provided by upstream for packaging purposes
  * Run tests as a part of a build process
  * Install full src tree (except pkg/debug) because go command depend
    on sources available
  * Install sources without testdata and *_test.go
  * Remove circular dependency golang-go->golang-doc->golang-go
  * Make sure that timestamp on installed binaries and libraries is same
    because go build/install recompiles everything if the go binary has
    more recent timestamp than libraries (Closes: #668235)
    + Need to update timestamps at postinst time because already created
      directories can have time in the past
  * Fix couple of lintian errors and warnings

 -- Ondřej Surý <ondrej@debian.org>  Wed, 11 Apr 2012 23:21:47 +0200

golang (2:1-2) unstable; urgency=low

  * Remove preserving of old -tools settings, there are too many options
    now anyway (Closes: #666007)

 -- Ondřej Surý <ondrej@debian.org>  Fri, 06 Apr 2012 16:52:13 +0200

golang (2:1-1) unstable; urgency=low

  * New major upstream release Go 1 (Closes: #666942)
  * Bumb epoch to 2, since 1 < 60 < 2011 (I wonder if next version will be 0 :)
  * Debconf templates and debian/control reviewed by the debian-l10n-
    english team as part of the Smith review project. (Closes: #663181)
  * [Debconf translation updates]
    + Pick existing translations from golang-weekly and do appropriate
      sed magic to fit golang templates. (Closes: #666884, #666880, #666881)
    + Dutch; (Jeroen Schot).  (Closes: #664598)
    + Czech (Michal Simunek).  (Closes: #665385)
    + Spanish; (Camaleón).  (Closes: #666177)
    + Danish (Joe Hansen).  (Closes: #666526)
  
 -- Ondřej Surý <ondrej@debian.org>  Fri, 06 Apr 2012 16:04:17 +0200

golang (1:60.3-2) unstable; urgency=low

  * debconf-gettextize package templates

 -- Ondřej Surý <ondrej@debian.org>  Mon, 20 Feb 2012 22:01:10 +0100

golang (1:60.3-1) unstable; urgency=low

  * Imported Upstream version 60.3

 -- Ondřej Surý <ondrej@debian.org>  Mon, 28 Nov 2011 08:46:18 +0100

golang (1:60.2-1) unstable; urgency=low

  * Imported Upstream version 60.2

 -- Ondřej Surý <ondrej@debian.org>  Thu, 06 Oct 2011 08:57:00 +0200

golang (1:60.1-1) unstable; urgency=low

  * Imported Upstream version 60.1

 -- Ondřej Surý <ondrej@debian.org>  Mon, 19 Sep 2011 10:18:12 +0200

golang (1:60-1) unstable; urgency=low

  * Imported Upstream version 60
  * Save upstream VERSION to the archive
  * Use GOVERSION as generated by src/version.bash on hg archive time
  * Add support for goinstall dashboard debconf question in the Debian
    packaging
  * Read goinstall dashboard option from debian configuration file
  * Remove 005-goinstall_dont_call_home_by_default.patch; replaced by
    configuration option
  * Fix directory name for upstream archive checkout

 -- Ondřej Surý <ondrej@debian.org>  Tue, 13 Sep 2011 13:13:59 +0200

golang (1:59-1) unstable; urgency=low

  * Imported Upstream version 59
  * Refresh patches to a new release
  * Fix FTBFS on ARM (Closes: #634270)
  * Update version.bash to work with Debian packaging and not hg
    repository

 -- Ondřej Surý <ondrej@debian.org>  Wed, 03 Aug 2011 17:04:59 +0200

golang (1:58.1-2) unstable; urgency=low

  * Install golang-doc package by default (Recommends from golang-tools,
    Depends from golang)

 -- Ondřej Surý <ondrej@debian.org>  Mon, 18 Jul 2011 09:13:43 +0200

golang (1:58.1-1) unstable; urgency=low

  * Imported Upstream version 58.1

 -- Ondřej Surý <ondrej@debian.org>  Wed, 13 Jul 2011 08:39:04 +0200

golang (1:58-1) unstable; urgency=low

  * Imported Upstream version 58
    + Add NEWS file with upstream API changes
  * Remove patch to not update standard package, fixed in upstream

 -- Ondřej Surý <ondrej@debian.org>  Thu, 30 Jun 2011 15:36:35 +0200

golang (1:57.2-1) unstable; urgency=low

  * Imported Upstream version 57.2
  * More spelling fixes (Closes: #630660)

 -- Ondřej Surý <ondrej@debian.org>  Thu, 16 Jun 2011 11:10:58 +0200

golang (1:57.1-4) unstable; urgency=low

  * Description update to have proper articles and capitalization
    (Closes: #630189)
  * Add extended description about Go being experimental and that the
    languager can change between releases

 -- Ondřej Surý <ondrej@debian.org>  Tue, 14 Jun 2011 21:38:11 +0200

golang (1:57.1-3) unstable; urgency=low

  * Fix "the Google's Go implementation" in extended description
    (Closes: #627814)
  * Update Vcs-* links
  * Install vim ftplugin files into correct directory (Closes: #629844)

 -- Ondřej Surý <ondrej@debian.org>  Thu, 09 Jun 2011 10:10:41 +0200

golang (1:57.1-2) unstable; urgency=low

  * Bump standards version to 3.9.2
  * Capitalize Kate (Closes: #627036)
  * Import slightly modified patch to be more clear about $GOPATH
    installs for non-root users
  * Remove don't install deps patch from goinstall; deprecated by
    $GOPATH installs

 -- Ondřej Surý <ondrej@debian.org>  Mon, 23 May 2011 11:07:11 +0200

golang (1:57.1-1) unstable; urgency=low

  * Add support for dot-minor releases
  * Imported Upstream version 57.1

 -- Ondřej Surý <ondrej@debian.org>  Mon, 16 May 2011 11:45:53 +0200

golang (1:57-3) unstable; urgency=low

  [ Florian Weimer ]
  * golang-tools: install gofix binary

  [ Ondřej Surý ]
  * Add lintian-overrides for gofix binary



=== debian/control ===
Source: golang
Section: devel
Priority: optional
Maintainer: Ondřej Surý <ondrej@debian.org>
Vcs-Browser: http://git.debian.org/?p=pkg-google/golang.git
Vcs-Git: git://git.debian.org/pkg-google/golang.git
Build-Depends: debhelper (>= 7.4.10), bison, ed, mawk | awk, perl, netbase
Build-Depends-Indep: po-debconf
Standards-Version: 3.9.3
Homepage: http://golang.org/

Package: golang-go
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends},
	 golang-src (>= ${source:Version})
Replaces: golang-weekly-go, golang-weekly-tools, golang-tools
Conflicts: golang-weekly-go, golang-weekly-tools, golang-tools
Provides: go-compiler, golang-weekly-go, golang-weekly-tools, golang-tools
Description: Go programming language compiler
 The Go programming language is an open source project to make
 programmers more productive. Go is expressive, concise, clean, and
 efficient. Its concurrency mechanisms make it easy to write programs
 that get the most out of multicore and networked machines, while its
 novel type system enables flexible and modular program construction.
 Go compiles quickly to machine code yet has the convenience of
 garbage collection and the power of run-time reflection. It's a
 fast, statically typed, compiled language that feels like a
 dynamically typed, interpreted language.
 .
 This package provides an assembler, a compiler, and a linker for the
 Go programming language. This is Google's implementation of the Go
 tool chain.

Package: golang-src
Replaces: golang-weekly-src, golang-go (<< 2:1-3~)
Conflicts: golang-weekly-src
Provides: golang-weekly-src
Breaks: golang-go (<< 2:1-3~)
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Go programming language compiler - source files
 The Go programming language is an open source project to make
 programmers more productive. Go is expressive, concise, clean, and
 efficient. Its concurrency mechanisms make it easy to write programs
 that get the most out of multicore and networked machines, while its
 novel type system enables flexible and modular program construction.
 Go compiles quickly to machine code yet has the convenience of
 garbage collection and the power of run-time reflection. It's a
 fast, statically typed, compiled language that feels like a
 dynamically typed, interpreted language.
 .
 This package provides the Go programming language source files needed
 for godoc and goinstall.

Package: golang-doc
Replaces: golang-weekly-doc
Conflicts: golang-weekly-doc
Provides: golang-weekly-doc
Depends: ${misc:Depends}, golang-go
Architecture: all
Section: doc
Description: Go programming language compiler - documentation
 The Go programming language is an open source project to make
 programmers more productive. Go is expressive, concise, clean, and
 efficient. Its concurrency mechanisms make it easy to write programs
 that get the most out of multicore and networked machines, while its
 novel type system enables flexible and modular program construction.
 Go compiles quickly to machine code yet has the convenience of
 garbage collection and the power of run-time reflection. It's a fast,
 statically typed, compiled language that feels like a dynamically
 typed, interpreted language.
 .
 This package provides the documentation for the Go programming
 language. You can view the formatted documentation by running "godoc
 --http=:6060", and then visiting http://localhost:6060/doc/install.html.

Package: golang-dbg
Replaces: golang-weekly-dbg
Conflicts: golang-weekly-dbg
Provides: golang-weekly-dbg
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 armel armhf
Depends: ${misc:Depends}, golang-go (= ${binary:Version})
Recommends: gdb
Section: debug
Priority: extra
Description: Go programming language compiler - debug files
 The Go programming language is an open source project to make
 programmers more productive. Go is expressive, concise, clean, and
 efficient. Its concurrency mechanisms make it easy to write programs
 that get the most out of multicore and networked machines, while its
 novel type system enables flexible and modular program construction.
 Go compiles quickly to machine code yet has the convenience of
 garbage collection and the power of run-time reflection. It's a
 fast, statically typed, compiled language that feels like a
 dynamically typed, interpreted language.
 .
 This package provides the debug symbols for Google's Go tool
 chain binaries (assembler, compiler, linker) needed for properly
 debugging errors in the tool chain with gdb.

Package: golang
Replaces: golang-weekly
Conflicts: golang-weekly
Provides: golang-weekly
Depends: ${misc:Depends},
	 golang-go (>= ${source:Version}),
	 golang-src (>= ${source:Version}),
	 golang-doc (>= ${source:Version})
Architecture: all
Description: Go programming language compiler - metapackage
 The Go programming language is an open source project to make
 programmers more productive. Go is expressive, concise, clean, and
 efficient. Its concurrency mechanisms make it easy to write programs
 that get the most out of multicore and networked machines, while its
 novel type system enables flexible and modular program construction.
 Go compiles quickly to machine code yet has the convenience of
 garbage collection and the power of run-time reflection. It's a
 fast, statically typed, compiled language that feels like a
 dynamically typed, interpreted language.
 .
 This package is a metapackage that, when installed, guarantees
 that (most of) a full Go development environment is installed.

Package: golang-mode
Architecture: all
Depends: ${misc:Depends}, emacs23 | emacsen
Suggests: golang-go
Description: Go programming language - mode for GNU Emacs
 This package provides a GNU Emacs major mode for editing code in
 Google's Go programming language.

Package: kate-syntax-go
Architecture: all
Depends: ${misc:Depends}, kate
Suggests: golang-go
Description: Go programming language - Kate highlighting syntax files
 This package provides syntax files for the Kate editor for editing code
 in Google's Go programming language.

Package: vim-syntax-go
Architecture: all
Depends: ${misc:Depends}, vim
Recommends: vim-addon-manager
Suggests: golang-go
Description: Go programming language - Vim highlighting syntax files
 This package provides syntax files for the Vim editor for editing code
 in Google's Go programming language.

=== debian/rules ===
#!/usr/bin/make -f
# This file is in the public domain.
# You may freely use, modify, distribute, and relicense it.

PACKAGE = golang

libexecdir := /usr/lib/go
datadir := /usr/share/go
bindir := /bin

build-arch build-indep build clean install binary-arch binary-indep binary: debian/control
	+dh --parallel $(opt_no_act) $@

override_dh_auto_clean:
	rm -rf bin pkg
	rm -f debian/*+
	rm -f debian/build.stamp
	rm -f test/pass.out test/run.out test/times.out
	rm -rf debian/home

override_dh_auto_build: debian/build.stamp

override_dh_auto_test:
ifeq ($(RUN_TEST), true)
	cd $(CURDIR)/src && \
	$(CURDIR)/debian/test.bash $(GOROOT)/pkg/tool/$(GOHOSTOS)_$(GOHOSTARCH);
else
	:
endif

override_dh_compress:
	dh_compress -Xusr/share/doc/$(PACKAGE)-doc/html -Xusr/share/doc/$(PACKAGE)-doc/godoc

override_dh_install:
	dh_install --fail-missing
	# Remove binary from documentation
	-rm $(CURDIR)/debian/golang-doc/usr/share/doc/golang-doc/html/articles/wiki/get.bin
	# Make scripts executable
	chmod +x $(CURDIR)/debian/golang-src/usr/share/go/src/cmd/godoc/setup-godoc-app.bash
	# Remove testdata and tests from installed src directory
	find $(CURDIR)/debian/golang-src/usr/share/go/src -type d -name testdata -prune -execdir rm -rf {} \;
	find $(CURDIR)/debian/golang-src/usr/share/go/src -type f -name '*_test.go' -delete
	# Touch built and installed files and directories to have same timestamp
	touch $(CURDIR)/debian/golang-go/usr/lib/go/pkg
	find $(CURDIR)/debian/golang-go/usr/lib/go/pkg -exec touch -r $(CURDIR)/debian/golang-go/usr/lib/go/pkg {} \;

override_dh_strip:
	dh_strip -X".a" -Xgoinstall -Xgodoc -Xgoyacc -Xbin/cgo -Xebnflint -Xgofix -Xgofmt -Xgovet -Xgotest --dbg-package=$(PACKAGE)-dbg

debian/build.stamp:
	rm -f debian/build.stamp
	mkdir -p $(GOBIN)
	+cd src && bash ./make.bash --no-banner
	>debian/build.stamp

opt_no_act =
RUN_TEST := true

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
    $(warning no support for disabling optimization)
endif

ifneq (,$(findstring n,$(MAKEFLAGS)))
    opt_no_act = --no-act
endif

ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
    RUN_TEST := false
endif

GOROOT := $(CURDIR)
GOROOT_FINAL := $(libexecdir)
GOBIN := $(CURDIR)$(bindir)
GOARM :=

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH 2>/dev/null)
DEB_HOST_ARCH_OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS 2>/dev/null)
DEB_HOST_ARCH_CPU := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU 2>/dev/null)
DEB_BUILD_ARCH_OS := $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS 2>/dev/null)
DEB_BUILD_ARCH_CPU := $(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU 2>/dev/null)

ifeq ($(DEB_BUILD_ARCH_OS), kfreebsd)
    RUN_TEST := false
    GOHOSTOS := freebsd
else ifeq ($(DEB_BUILD_ARCH_OS), linux)
    GOHOSTOS := linux
else
    $(error unrecongized build host kernel $(DEB_BUILD_ARCH_OS)!)
endif

ifeq ($(DEB_HOST_ARCH_OS), kfreebsd)
    RUN_TEST := false
    GOOS := freebsd
else ifeq ($(DEB_HOST_ARCH_OS), linux)
    GOOS := linux
else
    $(error unrecognized kernel $(DEB_HOST_ARCH_OS)!)
endif

ifeq ($(DEB_BUILD_ARCH_CPU), i386)
    GOHOSTARCH := 386
else ifeq ($(DEB_BUILD_ARCH_CPU), amd64)
    GOHOSTARCH := amd64
else ifeq ($(DEB_BUILD_ARCH_CPU), arm)
    GOHOSTARCH := arm
else ifeq ($(DEB_BUILD_ARCH_CPU), armhf)
    GOHOSTARCH := arm
else
    $(error unrecognized build host instruction set $(DEB_HOST_ARCH_CPU)!)
endif

ifeq ($(DEB_HOST_ARCH_CPU), i386)
    GOARCH := 386
    GOPREFIX := 8
else ifeq ($(DEB_HOST_ARCH_CPU), amd64)
    GOARCH := amd64
    GOPREFIX := 6
else ifeq ($(DEB_HOST_ARCH_CPU), arm)
    GOARCH := arm
    GOPREFIX := 5
ifeq ($(DEB_HOST_ARCH), armel)
    RUN_TEST := false
    GOARM := 5
else ifeq ($(DEB_HOST_ARCH), armhf)
    GOARM := 6
else
    $(error unrecognized arm architecture $(DEB_HOST_ARCH)!)
endif
else
    $(error unrecognized instruction set $(DEB_HOST_ARCH_CPU)!)
endif

export GOROOT GOROOT_FINAL GOOS GOARCH GOARM GOBIN GOHOSTARCH GOHOSTOS

REPO = https://go.googlecode.com/hg/
GOLANG_ORIG_DIR = $(CURDIR)/../go
REV = release
get-orig-source:
	-set -e; \
	if [ ! -d $(GOLANG_ORIG_DIR) ]; then \
		hg clone -r"$(REV)" "$(REPO)" "$(GOLANG_ORIG_DIR)"; \
	fi
	cd "$(GOLANG_ORIG_DIR)"; \
	hg pull; \
	hg update "$(REV)"; \
	VERSION=$$(cat VERSION | perl -e '<> =~ /go([\d.]+)/; print "$$1"'); \
	hg archive -tfiles -r"$(REV)" -X'.hg*' -X'doc/talks/go_talk-20091030.pdf' "$(CURDIR)/../$(PACKAGE)-$$VERSION/"; \
	cd ..; \
	tar -czf "$(CURDIR)/../$(PACKAGE)_$$VERSION.orig.tar.gz" "$(PACKAGE)-$$VERSION/"; \
	rm -rf "$(CURDIR)/../$(PACKAGE)-$$VERSION/"; \
	echo "Now run git-import-orig $(CURDIR)/../$(PACKAGE)_$$VERSION.orig.tar.gz"

.PHONY: build clean install binary-arch binary-indep binary

## golang 1.0.2

=== debian/changelog ===
golang (2:1.0.2-2) unstable; urgency=low

  * Add myself to uploaders, as discussed in #683421.
  * cherry-pick r820ffde8c396 (net/http: non-keepalive connections close
    successfully) (Closes: #683421)

 -- Michael Stapelberg <stapelberg@debian.org>  Thu, 02 Aug 2012 14:25:58 +0200

golang (2:1.0.2-1.1) unstable; urgency=low

  * Non-maintainer upload. (as discussed with Ondřej in #679692)
  * Fix godoc-symlinks.diff (godoc didn’t find docs) (Closes: #679692)

 -- Michael Stapelberg <stapelberg@debian.org>  Fri, 20 Jul 2012 17:59:38 +0200

golang (2:1.0.2-1) unstable; urgency=low

  [ Ondřej Surý ]
  * Imported Upstream version 1.0.2
  * Update Vcs fields to reflect new git repository location
  * Kill get-orig-source, since 1.0.0, the tarballs can be downloaded from
    webpage

  [ Michael Stapelberg ]
  * golang-mode: use debian-pkg-add-load-path-item (Closes: #664802)
  * add manpages (Closes: #632964)
  * Use updated pt.po from Pedro Ribeiro (Closes: #674958)

 -- Ondřej Surý <ondrej@sury.org>  Thu, 28 Jun 2012 12:14:15 +0200

golang (2:1.0.1-1) unstable; urgency=low

  * Imported Upstream version 1.0.1
  * Apply godoc patch to display package list correctly (Closes: #669354)

 -- Ondřej Surý <ondrej@debian.org>  Wed, 02 May 2012 15:44:59 +0200

golang (2:1-6) unstable; urgency=low

  * Merge upstream patch to fix homedir issue
    (http://code.google.com/p/go/source/detail?r=709120aecee0)
  * Disable GNU/KFreeBSD build (Closes: #668794)

 -- Ondřej Surý <ondrej@debian.org>  Wed, 18 Apr 2012 09:53:30 +0200

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,16 @@
 Section: devel
 Priority: optional
 Maintainer: Ondřej Surý <ondrej@debian.org>
-Vcs-Browser: http://git.debian.org/?p=pkg-google/golang.git
-Vcs-Git: git://git.debian.org/pkg-google/golang.git
+Uploaders: Michael Stapelberg <stapelberg@debian.org>
+Vcs-Browser: http://git.debian.org/?p=pkg-golang/golang.git
+Vcs-Git: git://git.debian.org/pkg-golang/golang.git
 Build-Depends: debhelper (>= 7.4.10), bison, ed, mawk | awk, perl, netbase
 Build-Depends-Indep: po-debconf
 Standards-Version: 3.9.3
 Homepage: http://golang.org/
 
 Package: golang-go
-Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 armel armhf
+Architecture: i386 amd64 armel armhf
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends},
 	 golang-src (>= ${source:Version})
 Replaces: golang-weekly-go, golang-weekly-tools, golang-tools
@@ -36,7 +37,7 @@
 Conflicts: golang-weekly-src
 Provides: golang-weekly-src
 Breaks: golang-go (<< 2:1-3~)
-Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 armel armhf
+Architecture: i386 amd64 armel armhf
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Go programming language compiler - source files
  The Go programming language is an open source project to make
@@ -78,7 +79,7 @@
 Replaces: golang-weekly-dbg
 Conflicts: golang-weekly-dbg
 Provides: golang-weekly-dbg
-Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 armel armhf
+Architecture: i386 amd64 armel armhf
 Depends: ${misc:Depends}, golang-go (= ${binary:Version})
 Recommends: gdb
 Section: debug
@@ -123,7 +124,7 @@
 
 Package: golang-mode
 Architecture: all
-Depends: ${misc:Depends}, emacs23 | emacsen
+Depends: ${misc:Depends}, emacs23 | emacsen, emacsen-common (>= 1.4.14)
 Suggests: golang-go
 Description: Go programming language - mode for GNU Emacs
  This package provides a GNU Emacs major mode for editing code in

=== debian/rules ===
--- 
+++ 
@@ -132,22 +132,4 @@
 
 export GOROOT GOROOT_FINAL GOOS GOARCH GOARM GOBIN GOHOSTARCH GOHOSTOS
 
-REPO = https://go.googlecode.com/hg/
-GOLANG_ORIG_DIR = $(CURDIR)/../go
-REV = release
-get-orig-source:
-	-set -e; \
-	if [ ! -d $(GOLANG_ORIG_DIR) ]; then \
-		hg clone -r"$(REV)" "$(REPO)" "$(GOLANG_ORIG_DIR)"; \
-	fi
-	cd "$(GOLANG_ORIG_DIR)"; \
-	hg pull; \
-	hg update "$(REV)"; \
-	VERSION=$$(cat VERSION | perl -e '<> =~ /go([\d.]+)/; print "$$1"'); \
-	hg archive -tfiles -r"$(REV)" -X'.hg*' -X'doc/talks/go_talk-20091030.pdf' "$(CURDIR)/../$(PACKAGE)-$$VERSION/"; \
-	cd ..; \
-	tar -czf "$(CURDIR)/../$(PACKAGE)_$$VERSION.orig.tar.gz" "$(PACKAGE)-$$VERSION/"; \
-	rm -rf "$(CURDIR)/../$(PACKAGE)-$$VERSION/"; \
-	echo "Now run git-import-orig $(CURDIR)/../$(PACKAGE)_$$VERSION.orig.tar.gz"
-
 .PHONY: build clean install binary-arch binary-indep binary

## golang 1.1

=== debian/changelog ===
golang (2:1.1-1) unstable; urgency=low

  * New upstream release: Go 1.1!
  * Remove the long obsolete goinstall debconf question and config file.
    goinstall does not exist anymore since a long time.
    This also obsoletes the need for any translations
    (Closes: #685923, #692478)
  * Emacs go-mode auto-mode-alist entry was fixed upstream (Closes: #670371)

 -- Michael Stapelberg <stapelberg@debian.org>  Tue, 14 May 2013 19:36:04 +0200

golang (2:1.1~hg20130405-1) experimental; urgency=low

  * Provide a new hg tip snapshot. This includes what was recently released as
    Go 1.1 beta.

 -- Michael Stapelberg <stapelberg@debian.org>  Fri, 05 Apr 2013 18:24:36 +0200

golang (2:1.1~hg20130323-1) experimental; urgency=low

  * Provide a new hg tip snapshot.
  * Add debian/watch (Closes: #699698)

 -- Michael Stapelberg <stapelberg@debian.org>  Sat, 23 Mar 2013 11:31:26 +0100

golang (2:1.1~hg20130304-2) experimental; urgency=low

  * Fix FTBFS of binary-arch only builds (as performed by buildds)
    caused by 'rm' not finding jquery.js in golang-doc
    (Thanks Peter Green)

 -- Michael Stapelberg <stapelberg@debian.org>  Tue, 05 Mar 2013 00:49:27 +0100

golang (2:1.1~hg20130304-1) experimental; urgency=low

  * Provide a hg tip snapshot (2013-03-04) in Debian experimental.
    Current hg tip is a good approximation to Go 1.1 and should get
    some testing within Debian in order to package Go 1.1 well when
    it is released. Thanks to Andrew Gerrand.

 -- Michael Stapelberg <stapelberg@debian.org>  Mon, 04 Mar 2013 21:28:58 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: Ondřej Surý <ondrej@debian.org>
 Uploaders: Michael Stapelberg <stapelberg@debian.org>
-Vcs-Browser: http://git.debian.org/?p=pkg-golang/golang.git
-Vcs-Git: git://git.debian.org/pkg-golang/golang.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-golang/golang.git
+Vcs-Git: git://anonscm.debian.org/pkg-golang/golang.git
 Build-Depends: debhelper (>= 7.4.10), bison, ed, mawk | awk, perl, netbase
 Build-Depends-Indep: po-debconf
 Standards-Version: 3.9.3
@@ -57,7 +57,7 @@
 Replaces: golang-weekly-doc
 Conflicts: golang-weekly-doc
 Provides: golang-weekly-doc
-Depends: ${misc:Depends}, golang-go
+Depends: ${misc:Depends}, golang-go, libjs-jquery
 Architecture: all
 Section: doc
 Description: Go programming language compiler - documentation

=== debian/rules ===
--- 
+++ 
@@ -33,13 +33,22 @@
 
 override_dh_install:
 	dh_install --fail-missing
-	# Remove binary from documentation
-	-rm $(CURDIR)/debian/golang-doc/usr/share/doc/golang-doc/html/articles/wiki/get.bin
+	# Replace jquery in the html documentation with a symlink to libjs-jquery.
+	-rm $(CURDIR)/debian/golang-doc/usr/share/doc/golang-doc/html/jquery.js && \
+	ln -s /usr/share/javascript/jquery/jquery.min.js $(CURDIR)/debian/golang-doc/usr/share/doc/golang-doc/html/jquery.js
 	# Make scripts executable
 	chmod +x $(CURDIR)/debian/golang-src/usr/share/go/src/cmd/godoc/setup-godoc-app.bash
 	# Remove testdata and tests from installed src directory
 	find $(CURDIR)/debian/golang-src/usr/share/go/src -type d -name testdata -prune -execdir rm -rf {} \;
 	find $(CURDIR)/debian/golang-src/usr/share/go/src -type f -name '*_test.go' -delete
+	# Remove .syso files of the race detector; it is not used yet and the files are arch-dependent.
+	find $(CURDIR)/debian/golang-src/usr/share/go/src/pkg/runtime/race -type f -name '*.syso' -delete
+	# Remove Plan9 rc(1) scripts
+	find $(CURDIR)/debian/golang-src/usr/share/go/src -type f -name "*.rc" -delete
+	# Remove empty /usr/share/go/src from golang-go, it is provided by golang-src
+	find $(CURDIR)/debian/golang-go/usr/share/go/src -type d -delete
+	# Subsequently, /usr/share/go is empty, too, so remove
+	find $(CURDIR)/debian/golang-go/usr/share/go -type d -delete
 	# Touch built and installed files and directories to have same timestamp
 	touch $(CURDIR)/debian/golang-go/usr/lib/go/pkg
 	find $(CURDIR)/debian/golang-go/usr/lib/go/pkg -exec touch -r $(CURDIR)/debian/golang-go/usr/lib/go/pkg {} \;

## golang 1.1.1

=== src/cmd/yacc/Makefile ===
# Copyright 2009 The Go Authors. All rights reserved.
# Use of this source code is governed by a BSD-style
# license that can be found in the LICENSE file.

units: yacc.go units.y
	go run yacc.go -p units_ units.y
	go build -o units y.go

clean:
	rm -f y.go y.output units

=== debian/changelog ===
golang (2:1.1.1-4) unstable; urgency=low

  * Disable stripping, it breaks go binaries on some architectures. This drops
    the golang-dbg package which would be empty now. (Thanks Robie Basak)
    (Closes: #717172)

 -- Michael Stapelberg <stapelberg@debian.org>  Wed, 17 Jul 2013 19:15:18 +0200

golang (2:1.1.1-3) unstable; urgency=low

  * Ship */runtime/cgo.a in golang-go to ensure it is present. It can only be
    used on the native architecture anyway (cannot be used when
    cross-compiling), so having it in golang-go-$GOOS-$GOARCH is not
    necessary. Even worse, since these packages are arch: all, they will be
    built precisely once, and only the runtime/cgo.a for the buildd’s native
    arch will be present. (Closes: #715025)

 -- Michael Stapelberg <stapelberg@debian.org>  Thu, 11 Jul 2013 20:25:52 +0200

golang (2:1.1.1-2) unstable; urgency=low

  [ James Page ]
  * Ensure smooth upgrade path from << 2:1.1-2 (Closes: #714838)

 -- Michael Stapelberg <stapelberg@debian.org>  Wed, 03 Jul 2013 18:05:58 +0200

golang (2:1.1.1-1) unstable; urgency=low

  * Imported Upstream version 1.1.1

 -- Ingo Oeser <nightlyone@googlemail.com>  Fri, 14 Jun 2013 23:25:44 +0200

golang (2:1.1-2) unstable; urgency=low

  [ Ondřej Surý ]
  * Promote Michael to Maintainer

  [ Michael Stapelberg ]
  * Build golang-go-$GOOS-$GOARCH packages for cross-compiling (Closes: #710090)
  * Build race detector on linux/amd64 (only supported arch) (Closes: #710691)
  * Switch compression to xz (50% smaller binaries)

 -- Michael Stapelberg <stapelberg@debian.org>  Fri, 07 Jun 2013 23:18:09 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
+# DO NOT EDIT THIS FILE. EDIT debian/control.* instead!
 Source: golang
 Section: devel
 Priority: optional
-Maintainer: Ondřej Surý <ondrej@debian.org>
-Uploaders: Michael Stapelberg <stapelberg@debian.org>
+Maintainer: Michael Stapelberg <stapelberg@debian.org>
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-golang/golang.git
 Vcs-Git: git://anonscm.debian.org/pkg-golang/golang.git
 Build-Depends: debhelper (>= 7.4.10), bison, ed, mawk | awk, perl, netbase
@@ -13,7 +13,8 @@
 Package: golang-go
 Architecture: i386 amd64 armel armhf
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends},
-	 golang-src (>= ${source:Version})
+	 golang-src (>= ${source:Version}),
+	 golang-go-linux-${go:Hostarch} (= ${source:Version})
 Replaces: golang-weekly-go, golang-weekly-tools, golang-tools
 Conflicts: golang-weekly-go, golang-weekly-tools, golang-tools
 Provides: go-compiler, golang-weekly-go, golang-weekly-tools, golang-tools
@@ -75,30 +76,6 @@
  language. You can view the formatted documentation by running "godoc
  --http=:6060", and then visiting http://localhost:6060/doc/install.html.
 
-Package: golang-dbg
-Replaces: golang-weekly-dbg
-Conflicts: golang-weekly-dbg
-Provides: golang-weekly-dbg
-Architecture: i386 amd64 armel armhf
-Depends: ${misc:Depends}, golang-go (= ${binary:Version})
-Recommends: gdb
-Section: debug
-Priority: extra
-Description: Go programming language compiler - debug files
- The Go programming language is an open source project to make
- programmers more productive. Go is expressive, concise, clean, and
- efficient. Its concurrency mechanisms make it easy to write programs
- that get the most out of multicore and networked machines, while its
- novel type system enables flexible and modular program construction.
- Go compiles quickly to machine code yet has the convenience of
- garbage collection and the power of run-time reflection. It's a
- fast, statically typed, compiled language that feels like a
- dynamically typed, interpreted language.
- .
- This package provides the debug symbols for Google's Go tool
- chain binaries (assembler, compiler, linker) needed for properly
- debugging errors in the tool chain with gdb.
-
 Package: golang
 Replaces: golang-weekly
 Conflicts: golang-weekly
@@ -146,3 +123,155 @@
 Description: Go programming language - Vim highlighting syntax files
  This package provides syntax files for the Vim editor for editing code
  in Google's Go programming language.
+
+Package: golang-go-linux-amd64
+Architecture: all
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
+Breaks: golang-go (<< 2:1.1-2)
+Replaces: golang-go (<< 2:1.1-2)
+Description: Go standard library compiled for linux_amd64
+ This package contains the Go standard library,
+ compiled for linux_amd64.
+ .
+ This package is just one of a number of packages, each providing the Go
+ standard library for a specific operating system/architecture combination.
+ Go supports cross-compilation, so each of these packages is useful on any
+ architecture.
+ .
+ The files contained in this package are independent of the host architecture,
+ that is, you can use golang-go-linux-amd64 to generate a binary for
+ linux_amd64, even though you are executing the Go compiler on linux_386.
+
+Package: golang-go-linux-arm
+Architecture: all
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
+Breaks: golang-go (<< 2:1.1-2)
+Replaces: golang-go (<< 2:1.1-2)
+Description: Go standard library compiled for linux_arm
+ This package contains the Go standard library,
+ compiled for linux_arm.
+ .
+ This package is just one of a number of packages, each providing the Go
+ standard library for a specific operating system/architecture combination.
+ Go supports cross-compilation, so each of these packages is useful on any
+ architecture.
+ .
+ The files contained in this package are independent of the host architecture,
+ that is, you can use golang-go-linux-amd64 to generate a binary for
+ linux_amd64, even though you are executing the Go compiler on linux_386.
+
+Package: golang-go-linux-386
+Architecture: all
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
+Breaks: golang-go (<< 2:1.1-2)
+Replaces: golang-go (<< 2:1.1-2)
+Description: Go standard library compiled for linux_386
+ This package contains the Go standard library,
+ compiled for linux_386.
+ .
+ This package is just one of a number of packages, each providing the Go
+ standard library for a specific operating system/architecture combination.
+ Go supports cross-compilation, so each of these packages is useful on any
+ architecture.
+ .
+ The files contained in this package are independent of the host architecture,
+ that is, you can use golang-go-linux-amd64 to generate a binary for
+ linux_amd64, even though you are executing the Go compiler on linux_386.
+
+Package: golang-go-freebsd-amd64
+Architecture: all
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
+Breaks: golang-go (<< 2:1.1-2)
+Replaces: golang-go (<< 2:1.1-2)
+Description: Go standard library compiled for freebsd_amd64
+ This package contains the Go standard library,
+ compiled for freebsd_amd64.
+ .
+ This package is just one of a number of packages, each providing the Go
+ standard library for a specific operating system/architecture combination.
+ Go supports cross-compilation, so each of these packages is useful on any
+ architecture.
+ .
+ The files contained in this package are independent of the host architecture,
+ that is, you can use golang-go-linux-amd64 to generate a binary for
+ linux_amd64, even though you are executing the Go compiler on linux_386.
+
+Package: golang-go-freebsd-arm
+Architecture: all
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
+Breaks: golang-go (<< 2:1.1-2)
+Replaces: golang-go (<< 2:1.1-2)
+Description: Go standard library compiled for freebsd_arm
+ This package contains the Go standard library,
+ compiled for freebsd_arm.
+ .
+ This package is just one of a number of packages, each providing the Go
+ standard library for a specific operating system/architecture combination.
+ Go supports cross-compilation, so each of these packages is useful on any
+ architecture.
+ .
+ The files contained in this package are independent of the host architecture,
+ that is, you can use golang-go-linux-amd64 to generate a binary for
+ linux_amd64, even though you are executing the Go compiler on linux_386.
+
+Package: golang-go-freebsd-386
+Architecture: all
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
+Breaks: golang-go (<< 2:1.1-2)
+Replaces: golang-go (<< 2:1.1-2)
+Description: Go standard library compiled for freebsd_386
+ This package contains the Go standard library,
+ compiled for freebsd_386.
+ .
+ This package is just one of a number of packages, each providing the Go
+ standard library for a specific operating system/architecture combination.
+ Go supports cross-compilation, so each of these packages is useful on any
+ architecture.
+ .
+ The files contained in this package are independent of the host architecture,
+ that is, you can use golang-go-linux-amd64 to generate a binary for
+ linux_amd64, even though you are executing the Go compiler on linux_386.
+
+Package: golang-go-windows-amd64
+Architecture: all
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
+Breaks: golang-go (<< 2:1.1-2)
+Replaces: golang-go (<< 2:1.1-2)
+Description: Go standard library compiled for windows_amd64
+ This package contains the Go standard library,
+ compiled for windows_amd64.
+ .
+ This package is just one of a number of packages, each providing the Go
+ standard library for a specific operating system/architecture combination.
+ Go supports cross-compilation, so each of these packages is useful on any
+ architecture.
+ .
+ The files contained in this package are independent of the host architecture,
+ that is, you can use golang-go-linux-amd64 to generate a binary for
+ linux_amd64, even though you are executing the Go compiler on linux_386.
+
+Package: golang-go-windows-386
+Architecture: all
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
+Breaks: golang-go (<< 2:1.1-2)
+Replaces: golang-go (<< 2:1.1-2)
+Description: Go standard library compiled for windows_386
+ This package contains the Go standard library,
+ compiled for windows_386.
+ .
+ This package is just one of a number of packages, each providing the Go
+ standard library for a specific operating system/architecture combination.
+ Go supports cross-compilation, so each of these packages is useful on any
+ architecture.
+ .
+ The files contained in this package are independent of the host architecture,
+ that is, you can use golang-go-linux-amd64 to generate a binary for
+ linux_amd64, even though you are executing the Go compiler on linux_386.
+
+Package: golang-go-darwin-amd64
+Architecture: all
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
+Breaks: golang-go (<< 2:1.1-2)
+Replaces: golang-go (<< 2:1.1-2)
+Description: Go standard library compiled for darwin_amd64
+ This package contains the Go standard library,

=== debian/rules ===
--- 
+++ 
@@ -8,11 +8,22 @@
 datadir := /usr/share/go
 bindir := /bin
 
+# We loop over supported operating systems and architectures multiple times,
+# so these two variables contain a centralized version of that code.
+# The variables $$os and $$arch can be used inside such a loop.
+FOR_GO_ARCH := for os in $$(echo linux freebsd windows darwin netbsd); do \
+	archs="amd64 386"; \
+	[ "$$os" = "linux" ] || [ "$$os" = "freebsd" ] && archs="amd64 arm 386"; \
+	for arch in $$(echo $$archs); do
+FOR_GO_ARCH_END := done; done
+
 build-arch build-indep build clean install binary-arch binary-indep binary: debian/control
 	+dh --parallel $(opt_no_act) $@
 
 override_dh_auto_clean:
 	rm -rf bin pkg
+	# golang-go-$os-$arch.install files are auto-generated in override_dh_install
+	rm -f debian/golang-go-*.install
 	rm -f debian/*+
 	rm -f debian/build.stamp
 	rm -f test/pass.out test/run.out test/times.out
@@ -31,7 +42,33 @@
 override_dh_compress:
 	dh_compress -Xusr/share/doc/$(PACKAGE)-doc/html -Xusr/share/doc/$(PACKAGE)-doc/godoc
 
+# Generates debian/control from debian/control.base and debian/control.cross.
+# In the latter, @OS@ and @ARCH@ are replaced with every supported combination
+# of operating system and architecture (e.g. linux_amd64, linux_386, …).
+gencontrol:
+	echo "# DO NOT EDIT THIS FILE. EDIT debian/control.* instead!" > debian/control.tmp
+	cat debian/control.base >> debian/control.tmp
+	${FOR_GO_ARCH} \
+		sed -e "s,@OS@,$$os,g; s,@ARCH@,$$arch,g" debian/control.cross >> debian/control.tmp; \
+	${FOR_GO_ARCH_END}
+	mv debian/control.tmp debian/control
+
 override_dh_install:
+	-${FOR_GO_ARCH} \
+		echo "pkg/$${os}_$${arch} /usr/lib/go/pkg/" > debian/golang-go-$$os-$$arch.install; \
+		[ "$$arch" = "amd64" ] && [ "$$os" = "linux" ] && echo "pkg/linux_amd64_race /usr/lib/go/pkg" >> debian/golang-go-$$os-$$arch.install; \
+		echo "golang-go-$$os-$$arch: arch-independent-package-contains-binary-or-object" > debian/golang-go-$$os-$$arch.lintian-overrides; \
+	${FOR_GO_ARCH_END}
+	# Install the native runtime/cgo.a to the golang-go package.
+	# runtime/cgo is only built for the native architecture, but the
+	# golang-go-OS-ARCH packages are built on one particular buildd, which
+	# might either be i386 or amd64.
+	echo "listing of $$(pwd):"; ls -hlR .
+	echo "listing of GOBIN: ($(GOBIN))"; ls -hlR $(GOBIN)
+	for file in $$(cd pkg/ && ls */runtime/cgo.a); do \
+		mkdir -p $(CURDIR)/debian/golang-go/usr/lib/go/pkg/$$(dirname $$file); \
+		mv pkg/$$file $(CURDIR)/debian/golang-go/usr/lib/go/pkg/$$file; \
+	done
 	dh_install --fail-missing
 	# Replace jquery in the html documentation with a symlink to libjs-jquery.
 	-rm $(CURDIR)/debian/golang-doc/usr/share/doc/golang-doc/html/jquery.js && \
@@ -49,17 +86,43 @@
 	find $(CURDIR)/debian/golang-go/usr/share/go/src -type d -delete
 	# Subsequently, /usr/share/go is empty, too, so remove
 	find $(CURDIR)/debian/golang-go/usr/share/go -type d -delete
+	# For some reason, Go cross-compiles a handful of tools: {yacc,fix,api,vet,cgo}.
+	# Delete those, as they cannot be ran anyway.
+	# This is tracked upstream at https://code.google.com/p/go/issues/detail?id=5667
+	(cd $(CURDIR)/debian/golang-go/usr/lib/go/pkg/tool && find . -depth -path "./$(GOHOSTOS)_$(GOHOSTARCH)*" -prune -o -delete)
 	# Touch built and installed files and directories to have same timestamp
 	touch $(CURDIR)/debian/golang-go/usr/lib/go/pkg
 	find $(CURDIR)/debian/golang-go/usr/lib/go/pkg -exec touch -r $(CURDIR)/debian/golang-go/usr/lib/go/pkg {} \;
 
 override_dh_strip:
-	dh_strip -X".a" -Xgoinstall -Xgodoc -Xgoyacc -Xbin/cgo -Xebnflint -Xgofix -Xgofmt -Xgovet -Xgotest --dbg-package=$(PACKAGE)-dbg
+	# strip disabled as golang upstream doesn't support it and it makes go
+	# crash. See http://bugs.debian.org/717172
+
+override_dh_prep:
+	dh_prep
+	echo 'go:Hostarch=$(GOHOSTARCH)' >> debian/golang-go.substvars
+
+override_dh_builddeb:
+	dh_builddeb -- -Zxz
 
 debian/build.stamp:
 	rm -f debian/build.stamp
 	mkdir -p $(GOBIN)
-	+cd src && bash ./make.bash --no-banner
+	# Build native tools first, then bootstrap all other GOOS/GOARCH combinations.
+	cd src && bash ./make.bash --no-banner
+	# For the race detector to work (go test -race), we need to install the
+	# std library with the race detector enabled. This will result in
+	# having an additional “architecture” directory, e.g. linux_amd64_race.
+	#
+	# The race detector currently only works on linux/amd64. The check within
+	# the following loop works precisely the same way src/race.bash does.
+	-${FOR_GO_ARCH} \
+		export GOARCH=$$arch; \
+		export GOOS=$$os; \
+		cd src && bash ./make.bash --no-clean; \
+		[ "$$arch" = "amd64" ] && [ "$$os" = "linux" ] && $(GOBIN)/go install -race std; \
+		cd ..; \
+	${FOR_GO_ARCH_END}
 	>debian/build.stamp
 
 opt_no_act =
